[From nobody Thu Aug 30 13:31:03 2018
X-Account-Key: account2
X-Mozilla-Keys: 
Return-Path: &lt;dermoth@localhost&gt;
Delivered-To: dermoth@aei.ca
Received: (qmail 27851 invoked by uid 89); 31 Mar 2010 06:59:34 -0000
Received: by simscan 1.2.0 ppid: 27844, pid: 27847, t: 0.5910s
 scanners: regex: 1.2.0 attach: 1.2.0 clamav: 0.95.3/m: spam: 3.3.0
X-Spam-Checker-Version: SpamAssassin 3.3.1 (2010-03-16)
X-Spam-Level: 
X-Spam-Status: No, hits=-3.0 required=5.0 tests=ALL_TRUSTED,BAYES_00
 autolearn=ham version=3.3.1
Received: from dsl-216-221-35-61.aei.ca (HELO localhost) (216.221.35.61)
 by mail.aei.ca with SMTP; 31 Mar 2010 06:59:33 -0000
Received: by localhost (Postfix, from userid 1000)
 id 6E6C34374BF; Wed, 31 Mar 2010 02:59:33 -0400 (EDT)
From: Thomas Guyot-Sionnest &lt;dermoth@aei.ca&gt;
To: Thomas Guyot-Sionnest &lt;dermoth@aei.ca&gt;
Cc: Thomas Guyot-Sionnest &lt;dermoth@aei.ca&gt;
Subject: [PATCH] check_snmp: Update last patch to copy value verbatim
Date: Wed, 31 Mar 2010 02:59:33 -0400
Message-Id: &lt;1270018773-28395-1-git-send-email-dermoth@aei.ca&gt;
X-Mailer: git-send-email 1.7.0.1

Rework last patch, copying the converted portion of the string rather
than re-converting it. This is safer for backwards-compatibility as the
value is never modified.
---
 NEWS                 |    1 +
 plugins/check_snmp.c |   11 ++++++++---
 2 files changed, 9 insertions(+), 3 deletions(-)

diff --git a/NEWS b/NEWS
index 58768d3..e261abf 100644
--- a/NEWS
+++ b/NEWS
@@ -11,6 +11,7 @@ This file documents the major additions and syntax changes between releases.
 	Try to detect arguments passed via --with-ping[6]-command and set options accordingly (#2908236)
 	Fix memory leak in check_http for large pages (Jimmy Bergman - #2957455)
 	Fix compilation with GCC 2.96 (Konstantin Khomoutov - #2977105)
+	Fix regression introduced in #1867716 where partially valid performance strings would not be printed anymore
 	WARNINGS
 	Updated developer documentation to say that performance labels should not have an equals sign or
 	single quote in the label
diff --git a/plugins/check_snmp.c b/plugins/check_snmp.c
index dcb3138..d393984 100644
--- a/plugins/check_snmp.c
+++ b/plugins/check_snmp.c
@@ -117,7 +117,7 @@ int needmibs = FALSE;
 int
 main (int argc, char **argv)
 {
-	int i;
+	int i, len;
 	int iresult = STATE_UNKNOWN;
 	int result = STATE_UNKNOWN;
 	int return_code = 0;
@@ -351,10 +351,15 @@ main (int argc, char **argv)
 		if (nunits &gt; (size_t)0 &amp;&amp; (size_t)i &lt; nunits &amp;&amp; unitv[i] != NULL)
 			asprintf (&amp;outbuff, &quot;%s %s&quot;, outbuff, unitv[i]);
 
-		if (is_numeric(show)) {
+		/* Write perfdata with whatever can can be parsed by strtod, if possible */
+		ptr = NULL;
+		strtod(show, &amp;ptr);
+		if (ptr &gt; show) {
 			strncat(perfstr, oidname, sizeof(perfstr)-strlen(perfstr)-1);
 			strncat(perfstr, &quot;=&quot;, sizeof(perfstr)-strlen(perfstr)-1);
-			strncat(perfstr, show, sizeof(perfstr)-strlen(perfstr)-1);
+			len = sizeof(perfstr)-strlen(perfstr)-1;
+			if (len &gt; ptr - show) len = ptr - show;
+			strncat(perfstr, show, len);
 
 			if (type)
 				strncat(perfstr, type, sizeof(perfstr)-strlen(perfstr)-1);
-- 
1.7.0.1



]